package com.example.vaadintreetable;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.data.Property.ValueChangeEvent;
import com.vaadin.data.Property.ValueChangeListener;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.Label;
import com.vaadin.ui.Notification;
import com.vaadin.ui.Table.HeaderClickEvent;
import com.vaadin.ui.Table.HeaderClickListener;
import com.vaadin.ui.TreeTable;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@Theme("vaadintreetable")
public class VaadintreetableUI extends UI {

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = VaadintreetableUI.class)
	public static class Servlet extends VaadinServlet {
	}

	@Override
	protected void init(VaadinRequest request) {
		final VerticalLayout layout = new VerticalLayout();
		layout.setMargin(true);
		setContent(layout);
		
		TreeTable tt = new TreeTable("Some Linux Distros ...");
		tt.setWidth("100%");
		tt.addContainerProperty("Name", String.class, null);
		tt.addContainerProperty("Year", String.class, null);
		
		tt.addItem(new Object[] {"Debian", "1993"}, 0);
		
		tt.addItem(new Object[] {"Knoppix", "2000"}, 1);
		tt.setParent(1, 0);
		tt.addItem(new Object[] {"Knotix", "2003"}, 2);
		tt.setParent(2, 1);
		tt.addItem(new Object[] {"Auditor Security Linux", "2004"}, 3);
		tt.setParent(3, 2);
		tt.addItem(new Object[] {"Backtrack", "2006"}, 4);
		tt.setParent(4, 3);
		tt.addItem(new Object[] {"Kali Linux", "2013"}, 5);
		tt.setParent(5, 4);

		
		tt.addItem(new Object[] {"Ubuntu", "2004"}, 20);
		tt.setParent(20, 0);
		tt.addItem(new Object[] {"Mint", "2006"}, 21);
		tt.setParent(21, 20);
		tt.addItem(new Object[] {"Lubuntu", "2009"}, 22);
		tt.setParent(22, 20);
		tt.addItem(new Object[] {"Elementary OS", "2011"}, 23);
		tt.setParent(23, 20);
		
		tt.addItem(new Object[] {"SLS", "1992"}, 30);
		tt.addItem(new Object[] {"Slackware", "1993"}, 31);
		tt.setParent(31, 30);
		tt.addItem(new Object[] {"S.u.S.E", "1994"}, 32);
		tt.setParent(32, 31);
		tt.addItem(new Object[] {"SuSE", "1998"}, 33);
		tt.setParent(33, 32);
		tt.addItem(new Object[] {"SUSE", "2003"}, 34);
		tt.setParent(34, 33);
		tt.addItem(new Object[] {"openSUSE", "2006"}, 35);
		tt.setParent(35, 34);
		
		tt.addItem(new Object[] {"Red Hat", "1994"}, 40);
		
		final Label current = new Label("Selected: NONE");
		tt.addValueChangeListener(new ValueChangeListener() {
			
			@Override
			public void valueChange(ValueChangeEvent event) {
				
				if(tt.getValue() != null){
					current.setValue("Selected: " + tt.getItem(tt.getValue()).toString());
				}else{
					current.setValue("Selected: NONE");
				}
			}
		});
		
		tt.addHeaderClickListener(new HeaderClickListener() {
			
			@Override
			public void headerClick(HeaderClickEvent event) {
				String column = (String) event.getPropertyId();
		        Notification.show("Column: " + column + " Mouse Button: " + event.getButtonName());
			}
		});
		
		layout.addComponent(current);
		layout.addComponent(tt);

	}

}